import numpy as np

# Skill, Major (College), No preference, Location, Industry, A-G, Degree
# Age, Gender
# Major: Science, Social, Engineering, Art

def to_one_hot(x, n_class):
    #s = np.size(x)
    x = x.reshape([-1,])
    
    d = np.eye(n_class)
    res = d[x]
    return res

def generate(n,p=4, seed = 0, one_hot = True):
    np.random.seed(seed)
    X_major = np.random.choice([0,1,2,3], n).reshape([-1,1])
    X_location = np.random.choice(np.arange(5), n, p=[0.2,0.2,0.2, 0.2, 0.2]).reshape([-1,1])
    X_industry = np.random.choice(np.arange(6), n).reshape([-1,1])
    #X_gender = np.random.choice([0,1], n).reshape([-1,1])

    if one_hot:
        X_major = to_one_hot(X_major, n_class = 4)
        X_location = to_one_hot(X_location, n_class = 5)
        X_industry = to_one_hot(X_industry, n_class = 6)
        #X_gender = to_one_hot(X_gender, n_class = 2)
    #print('X gender:', np.shape(X_gender) )
    #print('X major:', np.shape(X_major) )
        
    X  = np.concatenate([np.ones([n,1]), X_major, X_location, X_industry], axis = 1)

    Z_major = np.random.choice([0,1,2,3], n).reshape([-1,1])
    Z_location = np.random.choice(np.arange(5), n, p=[0.2,0.2,0.2, 0.2, 0.2]).reshape([-1,1])
    Z_industry = np.random.choice(np.arange(6), n, ).reshape([-1,1])
    #Z_gender = np.random.choice([0,1], n).reshape([-1,1])
    
    if one_hot:
        Z_major = to_one_hot(Z_major, n_class =  4)
        Z_location = to_one_hot(Z_location, n_class = 5)
        Z_industry = to_one_hot(Z_industry, n_class = 6)
        #Z_gender = to_one_hot(Z_gender, n_class = 2)
    Z  = np.concatenate([np.ones([n,1]), Z_major, Z_location, Z_industry], axis = 1)

    return (X, Z)

    
    
