import numpy as np
from scipy.optimize import linear_sum_assignment
#from sklearn.linear_model import LinearRegression
#import matplotlib.pyplot as plt
#from sklearn import metrics
from scipy.optimize import minimize
import os
import argparse
import time
from generate_data import *
#from method import *

parser = argparse.ArgumentParser(description='1d simulation')
parser.add_argument('--n', type=int, default=200)
#parser.add_argument('--p', type=int, default=10)
parser.add_argument('--n_round', type = int, default=20)
parser.add_argument('--eps', type = float, default = 0)
parser.add_argument('--p_reveal', type = float, default = 1.0)
#parser.add_argument('--n_repeat', type = int, default=50)
parser.add_argument('--alpha', type = float, default=0)
parser.add_argument('--seed', type = int, default=0)

args = parser.parse_args()

n = args.n


n_round = args.n_round
#n_repeat = args.n_repeat

sigma = 0.5
alpha = args.alpha

p_reveal = args.p_reveal

eps = args.eps



Eps = np.zeros([n_round])
Eps[0] = args.eps
for i in range(1, n_round):
    Eps[i] = Eps[i-1]/np.sqrt(i+1)



np.random.seed(args.seed)

#h = np.random.normal([1,1,5,5,5])
#beta_0_true = 1
#beta_true = np.array([2, -2, -1,-1])
#beta_score_true = np.array([2.48, 0.0693, 0.0693, 0.0693, 2.5, 2,1,1,0.5,0.5, 2, 2, 1.5, 0,0])
beta_true = np.concatenate([[2.48,], 0.0693*np.ones([4,]), \
                                  0.0734 * np.ones([5,]), \
                                  0.0575*np.ones([6,])], axis = 0)


p = np.size(beta_true) 
print('beta_true:', np.shape(beta_true))
#beta_true = np.array([-3,0.5,3,1,2])


def phi(x,z):
    res = (x*z).reshape([-1,1])
    return res
    

def UCB(x,z, alpha, M_inv,beta):
    v = phi(x,z)
    return v.T.dot(beta) + alpha*np.sqrt(v.T.dot(M_inv).dot(v))

def utility(x,z,beta_true):
    beta_true = beta_true.reshape([-1,1])
    #print(phi(x,z))
    #print(beta_true)
    return phi(x,z).T.dot(beta_true)

def sim_score(X,Z, beta_score = 0):
    D = X*Z
    s = np.shape(X)[0]
    D = np.concatenate([np.ones([s,1]), D], axis = 1)
    p = np.shape(X)[1]
    if np.size(beta_score) == 1:
        beta_score = np.zeros([p+1,1])
    beta_score = np.array(beta_score).reshape([-1,1])
    S = D.dot(beta_score)
    
    return S

def mse(X, Y):
    n = np.size(X)
    return np.sum((X-Y)**2)/n

def SE(x,y):
    x = x.reshape([-1,1])
    y = y.reshape([-1,1])
    return np.sum((x-y)**2)

    
Reward_opt_avg = []
Reward_rand_avg = []
Reward_eps_greedy_avg = []

try:
    os.makedirs('random_match/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/')
except:
    None

for r in range(1):
    #print('Repetition', r, 'begin...')
    Reward_opt = []
    Reward = []
    Regret = []
    M = np.eye(p)
    r = np.zeros([p,1])

    Beta_hat = []
    Beta_SE = []
    

    
    #beta_0 = 0
    #beta = np.array([0, -0.1,-0.1,-0.1,-0.1,-0.1])
    #beta = np.zeros([p+1,])
    #beta = np.random.normal(0,1, [p+1,])
    #beta = np.zeros([3*p+1,1])
    #sigma_square = 1
    '''Gamma_hat = np.zeros([p,p])
    #Gamma_est = [Gamma_hat,]
    Gamma_est_mse = [mse(Gamma_hat, Gamma_true),]'''
    start = time.time()
    #count = 0
    for k in range(n_round):
        print('------ Round ', k, '------------')
        #M_inv = np.linalg.inv(M)
        #beta_hat = M_inv.dot(r)
        #Beta_SE.append(SE(beta_hat, beta_true))
        
        (X,Z) = generate(n, p=4, seed = args.seed, one_hot = True)
        #X = np.random.normal(0, 1, [n,p])
        #Z = np.random.normal(0, 1, [n,p])

        X_reveal = []
        Z_reveal = []
        R_reveal = []

        R_true = np.zeros([n,n])
        R = np.zeros([n,n])

        for i in range(n):
            for j in range(n):              
                #R_true[i,j] = round(float(X[[i],:].reshape([1,-1]).dot(Gamma_true).dot(Z[[j], :].reshape([-1,1]))))
                #R[i,j] = X[[i],:].reshape([1,-1]).dot(Gamma_hat).dot(Z[[j], :].reshape([-1,1]))
                #print('beta_true:', beta_true)
                R_true[i,j] = utility(X[[i]], Z[[j]], beta_true = beta_true) 
                #score_oracle = sim_score(X[[i]], Z[[j]], beta_score = beta_score_true)
                #R_true[i,j]  = int(score_oracle > 4)
                #R_true[i,j] = p_success(X[[i]], Z[[j]], beta = beta_true)
                
        row_ind_opt, col_ind_opt = linear_sum_assignment(-R_true)
        
                    
        '''if np.random.binomial(1, Eps[k]) == 1:
            col_ind = np.random.permutation(n)
        else:'''
        '''for i in range(n):
            for j in range(n):              
                #x = np.concatenate([[[1]], X[[i],:], Z[[j], :], X[[i],:] * Z[[j], :]], axis = 1)                       
                R[i,j] = float(UCB(X[[i],:], Z[[j],:], alpha= alpha, M_inv = M_inv, beta = beta_hat))
                #float(x.dot(beta))
                #+ Eps[k]*np.random.normal(0,1,1)
                if np.random.binomial(1, 0.0001, 1)==1:
                    print(R_true[i,j], R[i,j])
        row_ind, col_ind = linear_sum_assignment(-R)'''
        col_ind = np.random.permutation(n)
                       
        
        '''if np.random.binomial(1, eps, 1) == 1:
            col_ind = np.random.permutation(n)
        else:'''
            
        
     
        R_opt = 0
        R = 0

        Outcome = []
        regret = 0
        for i in range(n):
            R_opt += R_true[i, col_ind_opt[i]] 
            out = R_true[i, col_ind[i]] + np.random.normal(0,sigma)
            Outcome.append(out)
            #R += out
            R += R_true[i, col_ind[i]]
            regret += R_true[i, col_ind_opt[i]] - R_true[i, col_ind[i]]

            
        Reward_opt.append(R_opt/n)
        Reward.append(R/n)
        Regret.append(regret)
        print('regret:', regret)

        Reveal = np.random.binomial(1, p_reveal, [n,])       
        index_reveal = np.where(Reveal == 1)[0]

        
        '''for i in index_reveal:
            phi_i = phi(X[i,:], Z[col_ind[i], :])
            M = M + phi_i.dot(phi_i.T)
            r = r+Outcome[i]*phi_i'''

    end = time.time()
    

    np.savetxt('random_match/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_reward.txt', Reward)
    np.savetxt('random_match/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_reward_oracle.txt', Reward_opt)
    np.savetxt('random_match/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_regret.txt', Regret)
    #np.savetxt('UCB_case_study/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_beta_SE.txt', Beta_SE)
    np.savetxt('random_match/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_time.txt', [end - start])

    
    '''Reward_opt_avg.append(np.mean(Reward_opt))
    Reward_rand_avg.append(np.mean(Reward_rand))
    Reward_greedy_avg.append(np.mean(Reward_greedy))
    Reward_eps_greedy_avg.append(np.mean(Reward_eps_greedy))'''

    
'''print('Reward_opt avg:', np.mean(Reward_opt))
print('Reward_rand:', np.mean(Reward_rand))
print('Reward_greedy:', np.mean(Reward_greedy))
print('Reward_eps_greedy:', np.mean(Reward_eps_greedy))

print('Gamma_est_greedy:', Gamma_est_greedy)
print('Gamma_est_eps_greedy:', Gamma_est_eps_greedy)'''
'''
print('std opt:', np.std(Reward_opt_avg))
print('std rand:', np.std(Reward_rand_avg))
print('std greedy:', np.std(Reward_greedy_avg))
print('std eps greedy:', np.std(Reward_eps_greedy_avg))
'''

'''plt.figure()
plt.xlabel('# Round')
plt.ylabel(r'$\hat{\Gamma}$')
plt.plot(np.arange(n_round+1), np.reshape(Gamma_est_greedy, [-1,]), label = 'Greedy')
plt.plot(np.arange(n_round+1), np.reshape(Gamma_est_eps_greedy,[-1,]), label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('Gamma_est_1d.png')

plt.figure()
plt.xlabel('# Round')
plt.ylabel(r'MSE of $\Gamma$ estimate')
plt.plot(np.arange(n_round+1), (np.reshape(Gamma_est_greedy, [-1,]) - 1)**2, label = 'Greedy')
plt.plot(np.arange(n_round+1), (np.reshape(Gamma_est_eps_greedy, [-1,]) - 1)**2, label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('Gamma_mse_1d.png')

plt.figure()
plt.xlabel('# Round')
plt.ylabel('Reward')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_opt, [-1,]), label = 'Oracle')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_rand, [-1,]), label = 'Random')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_greedy, [-1,]), label = 'Greedy')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_eps_greedy,[-1,]), label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('reward_1d.png')'''

