import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl

mpl.rcParams['lines.linewidth'] = 3
mpl.rcParams['legend.fontsize'] = 18
mpl.rcParams['xtick.labelsize'] = 12
mpl.rcParams['ytick.labelsize'] = 12
mpl.rcParams['axes.titlesize'] = 18
mpl.rcParams['axes.labelsize'] = 18

def cumulate(x):
    temp = x[0]
    for i in range(len(x)-1):
        x[i+1] = temp + x[i+1]
        temp = x[i+1]
    return x

transparency = 0

T = 100
plt.figure(figsize = (10,8))
n_repeat = 20
for p in [100,]:
    for alpha in np.arange(0, 1.1,0.2):
        label =r' $\alpha=$'+'%.1f'%alpha # r'$p=$'+str()+
        folder = 'linear_regression/n-50_T-100_p-'+str(p)+'_alpha-'+'%.1f'%alpha+'/'
        Beta_SE = []
        for i in range(n_repeat):
            beta_SE = np.loadtxt(folder + str(i)+'_beta_SE.txt')
            Beta_SE.append(beta_SE)

        mean = np.mean(Beta_SE, axis = 0)
        std = np.std(Beta_SE, axis = 0)
        plt.plot(np.arange(T)+1, mean, label = label)
        plt.fill_between(np.arange(T)+1, mean - std, mean+std, alpha = transparency)

plt.xlabel(r'$t$')
plt.ylabel(r'$\ell_2$ error of $\theta^*$ estimate')
plt.legend()
plt.savefig('SE_plot_p-100_0.2.png')
plt.close()
