import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl

mpl.rcParams['lines.linewidth'] = 3
mpl.rcParams['legend.fontsize'] = 18
mpl.rcParams['xtick.labelsize'] = 12
mpl.rcParams['ytick.labelsize'] = 12
mpl.rcParams['axes.titlesize'] = 18
mpl.rcParams['axes.labelsize'] = 18

def cumulate(x):
    temp = x[0]
    for i in range(len(x)-1):
        x[i+1] = temp + x[i+1]
        temp = x[i+1]
    return x

transparency = 0

T = 100
plt.figure(figsize = (10,8))
n_repeat = 20
nt=50
p = 10
for p in [p]:
    for alpha in [0, 0.5, 1, 2,3]:
        label =r' $\lamda=$'+'%.1f'%alpha # r'$p=$'+str()+
        folder = 'ridge_regression/n-50_T-100_p-'+str(p)+'_alpha-'+'%.1f'%alpha+'/'
        Regret = []
        for i in range(n_repeat):
            regret = np.loadtxt(folder + str(i)+'_regret.txt')
            regret = cumulate(regret)
            Regret.append(regret)

        
        mean = np.mean(Regret, axis = 0)/nt
        std = np.std(Regret, axis = 0)/nt
        plt.plot(np.arange(T)+1, mean, label = label)
        plt.fill_between(np.arange(T)+1, mean - std, mean+std, alpha = transparency)
        print('lambda=', '%.1f'%alpha, '%.2f'%mean[-1], '('+'%.2f'%std[-1]+')')

'''label = 'Random Match'
folder = 'linear_regression_random/n-50_T-100_p-'+str(p)+'_alpha-0.0/'
Regret = []
for i in range(n_repeat):
    regret = np.loadtxt(folder + str(i)+'_regret.txt')
    regret = cumulate(regret)
    Regret.append(regret)


mean = np.mean(Regret, axis = 0)/nt
std = np.std(Regret, axis = 0)/nt
plt.plot(np.arange(T)+1, mean, label = label)
plt.fill_between(np.arange(T)+1, mean - std, mean+std, alpha = transparency)
print('Random:', '%.2f'%mean[-1], '('+'%.2f'%std[-1]+')')'''

## TS
'''
label =r'Naive Thompson Sampling' # r'$p=$'+str()+
folder = 'linear_regression_TS/n-50_T-100_p-'+str(p)+'/'
Regret = []
for i in range(n_repeat):
    reward = np.loadtxt(folder + str(i)+'_reward.txt')
    reward_oracle = np.loadtxt(folder + str(i)+'_reward_oracle.txt')
    regret = np.loadtxt(folder + str(i)+'_regret.txt')
    #print('reward:',reward)
    #print('reward oracle:',reward_oracle)
    #regret = reward_oracle - reward
    regret = cumulate(regret)
    Regret.append(regret)


mean = np.mean(Regret, axis = 0)/nt
std = np.std(Regret, axis = 0)/nt
plt.plot(np.arange(T)+1, mean, label = label)
plt.fill_between(np.arange(T)+1, mean - std, mean+std, alpha = transparency)
print('TS:', '%.2f'%mean[-1], '('+'%.2f'%std[-1]+')')
'''

plt.xlabel('t')
plt.ylabel('Cumulative regret')
plt.legend(loc = 'lower right')
plt.savefig('regret_plot_p-'+str(p)+'_sparse.pdf', bbox_inches='tight')
plt.close()
