import numpy as np
from scipy.optimize import linear_sum_assignment
#from sklearn.linear_model import LinearRegression
import matplotlib.pyplot as plt
#from sklearn.kernel_ridge import KernelRidge
#from sklearn import metrics
from scipy.optimize import minimize
import os
import argparse
import time
#from  network import *

def norm_2(x):
    return np.sqrt(np.sum(x**2))


parser = argparse.ArgumentParser(description='1d simulation')
parser.add_argument('--n', type=int, default=100)
#parser.add_argument('--p', type=int, default=10)
parser.add_argument('--n_round', type = int, default=10)
parser.add_argument('--eps', type = float, default = 0)
parser.add_argument('--p_reveal', type = float, default = 1)
#parser.add_argument('--gamma0', type = float, default=0)
parser.add_argument('--seed', type = int, default=0)
parser.add_argument('--alpha', type = float, default=1)
parser.add_argument('--p', type = int, default=1)
#parser.add_argument('--lr_init', type = float, default=0.1)

args = parser.parse_args()

n = args.n


n_round = args.n_round
#n_repeat = args.n_repeat

sigma = 1

p_reveal = args.p_reveal

eps = args.eps

#kernel = 'rbf'

Eps = np.zeros([n_round])
Eps[0] = args.eps
for i in range(1, n_round):
    Eps[i] = Eps[i-1]/np.sqrt(i+1)



np.random.seed(args.seed)

#h = np.random.normal([1,1,5,5,5])
#beta_0_true = 1
#beta_true = np.array([2, -2, -1,-1])

p = args.p


alpha = args.alpha
beta_true = np.concatenate([np.array([-1,1,2,3,4]), -np.ones([p-5,])], axis = 0)
#print(beta_true)
beta_true = beta_true/norm_2(beta_true)
print('beta_true:', beta_true)

#beta_true = 2*np.concatenate([np.array([0, 2, 2, 1, 1, 1,]), np.zeros([p-5,])],axis = 0)
#gamma = args.gamma0*np.concatenate([np.array([0, ]), np.random.normal(0,1,[p,])],axis = 0).reshape([-1,1])
#beta_true = np.concatenate([np.array([0, 2, 2, 1, 1, 1,]), np.zeros([495,])],axis = 0)

def phi(x,z):
    return (x*z).reshape([-1,1])

def UCB(x,z, alpha, M_inv,beta):
    v = phi(x,z)
    return v.T.dot(beta) + alpha*np.sqrt(v.T.dot(M_inv).dot(v))

def utility(x,z,beta_true):
    beta_true = beta_true.reshape([-1,1])
    #print(phi(x,z))
    #print(beta_true)
    return phi(x,z).T.dot(beta_true)

def interact(X,Z):
    (n,p) = np.shape(X)
    out = np.zeros([n,p*p])
    for i in range(n):
        out[i,:] = np.outer(X[i,:], Z[i,:]).reshape([-1,])
    return out
        

def pred_score(beta, X, Z):
    s = np.shape(X)[0]
    D = X*Z
    D = np.concatenate([np.ones([s,1]), D], axis = 1)
    res = D.dot(beta)
    #out = F.softmax(out, dim = 1)
    
    return res

def update_lr(X_reveal, Z_reveal, R_reveal):
    s = np.shape(X_reveal)[0]
    X_reveal = np.array(X_reveal)
    Z_reveal = np.array(Z_reveal)
    D = X_reveal * Z_reveal
    D = np.concatenate([np.ones([s,1]), D], axis = 1) 
    R_reveal = np.array(R_reveal).reshape([-1,1])
    res = np.linalg.inv(D.T.dot(D)).dot(D.T).dot(R_reveal)
    return res

def logit(x):
    return np.exp(x)/(1+np.exp(x))



def score(X, Z, beta = 0, gamma = 0):
    D = X*Z
    s = np.shape(X)[0]
    D = np.concatenate([np.ones([s,1]), D], axis = 1)
    p = np.shape(X)[1]
    if np.size(beta) == 1:
        beta = np.zeros([p+1,1])
    if np.size(gamma) == 1:
        gamma = np.zeros([p+1,1])
    beta = np.array(beta).reshape([-1,1])
    f = (D**2).dot(beta)
    f = np.round(f)
    f = np.clip(f, 0, 10)
    #+ (D**2).dot(gamma)
    #print('D:', D)
    '''if output:
        print('beta:', beta)
        print('f:',f)'''
    return f



def mse(X, Y):
    n = np.size(X)
    return np.sum((X-Y)**2)/n

def SE(x,y):
    x = x.reshape([-1,1])
    y = y.reshape([-1,1])
    return np.sum((x-y)**2)






        

Reward_opt_avg = []
Reward_rand_avg = []
Reward_eps_greedy_avg = []



try:
    os.makedirs('linear_regression_random/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/')
except:
    None

for r in range(1):
    print('Repetition', r, 'begin...')
    Reward_opt = []
    Reward = []
    Regret = []
    M = np.eye(p)
    r = np.zeros([p,1])

    Beta_hat = []
    Beta_SE = []
    


    start = time.time()
    
    for k in range(n_round):
        '''M_inv = np.linalg.inv(M)
        
        beta_hat = M_inv.dot(r)
        print('beta_hat:', beta_hat)
        print('beta_SE:', SE(beta_hat, beta_true))
        Beta_SE.append(SE(beta_hat, beta_true))'''
        
        X = np.random.normal(0, 1, [n,p])
        Z = np.random.normal(0, 1, [n,p])

        
        X_reveal = []
        Z_reveal = []
        R_reveal = []
        R_true = np.zeros([n,n])
        R = np.zeros([n,n])
        #print('beta_true:', beta_true)

        for i in range(n):
            for j in range(n):              
                #R_true[i,j] = round(float(X[[i],:].reshape([1,-1]).dot(Gamma_true).dot(Z[[j], :].reshape([-1,1]))))
                #R[i,j] = X[[i],:].reshape([1,-1]).dot(Gamma_hat).dot(Z[[j], :].reshape([-1,1]))
                #print('beta_true:', beta_true)
                R_true[i,j] = utility(X[[i]], Z[[j]], beta_true = beta_true)                
        row_ind_opt, col_ind_opt = linear_sum_assignment(-R_true)
                    
        '''if np.random.binomial(1, Eps[k]) == 1:
            col_ind = np.random.permutation(n)
        else:'''
        '''for i in range(n):
            for j in range(n):              
                #print('score:',  pred_score(model, X[[i],:], Z[[j],:]))
                R[i,j] = float(UCB(X[[i],:], Z[[j],:], alpha= alpha, M_inv = M_inv, beta = beta_hat))
                #float(x.dot(beta))
                #+ Eps[k]*np.random.normal(0,1,1)
                if np.random.binomial(1, 0.0001, 1)==1:
                    print(R_true[i,j], R[i,j])'''
        col_ind = np.random.permutation(n)
                       
        
        '''if np.random.binomial(1, eps, 1) == 1:
            col_ind = np.random.permutation(n)
        else:'''
            
        
     
        R_opt = 0
        R = 0

        Outcome = []
        regret = 0
        for i in range(n):
            R_opt += R_true[i, col_ind_opt[i]] 
            out = R_true[i, col_ind[i]] + np.random.normal(0,sigma)
            Outcome.append(out)
            #R += out
            R += R_true[i, col_ind[i]]
            regret += R_true[i, col_ind_opt[i]] - R_true[i, col_ind[i]]
            
        
            
        Reward_opt.append(R_opt/n)
        Reward.append(R/n)
        Regret.append(regret)
        print('regret:', regret)
        #print('R_opt:', R_opt/n)
        #print('R_lr:', R/n)

        Reveal = np.random.binomial(1, p_reveal, [n,])       
        index_reveal = np.where(Reveal == 1)[0]

        
        '''for i in index_reveal:
            phi_i = phi(X[i,:], Z[col_ind[i], :])
            M = M + phi_i.dot(phi_i.T)
            r = r+Outcome[i]*phi_i'''
            #X_reveal.append(X[i,:])
            #Z_reveal.append(Z[col_ind[i], :])
            #R_reveal.append(Outcome[i])

        #beta = update_lr(X_reveal, Z_reveal, R_reveal)

        #print('beta update:', beta)

    '''try:
        os.makedirs('Gamma_mse/eps_'+'%.2f'%(eps)+'/')
    except:
        None'''
    end = time.time()
    
        
    #np.savetxt('Gamma_mse/eps_'+'%.2f'%(eps)+'/'+str(r)+'.txt', Gamma_est_mse)
    np.savetxt('linear_regression_random/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_reward.txt', Reward)
    np.savetxt('linear_regression_random/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_reward_oracle.txt', Reward_opt)
    np.savetxt('linear_regression_random/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_regret.txt', Regret)
    #np.savetxt('linear_regression/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_beta_SE.txt', Beta_SE)
    np.savetxt('linear_regression_random/n-'+str(n)+'_T-'+str(n_round)+'_p-'+str(p)+'_alpha-'+str(alpha)+'/'+str(args.seed)+'_time.txt', [end - start])
    
    '''Reward_opt_avg.append(np.mean(Reward_opt))
    Reward_rand_avg.append(np.mean(Reward_rand))
    Reward_greedy_avg.append(np.mean(Reward_greedy))
    Reward_eps_greedy_avg.append(np.mean(Reward_eps_greedy))'''

    
'''print('Reward_opt avg:', np.mean(Reward_opt))
print('Reward_rand:', np.mean(Reward_rand))
print('Reward_greedy:', np.mean(Reward_greedy))
print('Reward_eps_greedy:', np.mean(Reward_eps_greedy))

print('Gamma_est_greedy:', Gamma_est_greedy)
print('Gamma_est_eps_greedy:', Gamma_est_eps_greedy)'''
'''
print('std opt:', np.std(Reward_opt_avg))
print('std rand:', np.std(Reward_rand_avg))
print('std greedy:', np.std(Reward_greedy_avg))
print('std eps greedy:', np.std(Reward_eps_greedy_avg))
'''

'''plt.figure()
plt.xlabel('# Round')
plt.ylabel(r'$\hat{\Gamma}$')
plt.plot(np.arange(n_round+1), np.reshape(Gamma_est_greedy, [-1,]), label = 'Greedy')
plt.plot(np.arange(n_round+1), np.reshape(Gamma_est_eps_greedy,[-1,]), label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('Gamma_est_1d.png')

plt.figure()
plt.xlabel('# Round')
plt.ylabel(r'MSE of $\Gamma$ estimate')
plt.plot(np.arange(n_round+1), (np.reshape(Gamma_est_greedy, [-1,]) - 1)**2, label = 'Greedy')
plt.plot(np.arange(n_round+1), (np.reshape(Gamma_est_eps_greedy, [-1,]) - 1)**2, label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('Gamma_mse_1d.png')

plt.figure()
plt.xlabel('# Round')
plt.ylabel('Reward')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_opt, [-1,]), label = 'Oracle')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_rand, [-1,]), label = 'Random')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_greedy, [-1,]), label = 'Greedy')
plt.plot(np.arange(n_round)+1, np.reshape(Reward_eps_greedy,[-1,]), label = r'$\epsilon$-greedy')
plt.legend()
plt.savefig('reward_1d.png')'''

